#include <iostream>
#include <vector>
#include <math.h>
#include <sstream>
#include <string>
#include <stdlib.h>
#include <stdio.h>
#include <curl/curl.h>
#include "histogram.h"
#include "text.h"
#include "svg.h"

using namespace std;

    struct Input {
    vector<double>A;
    size_t bin{};
    };

size_t write_data(void* items, size_t item_size, size_t item_count, void* ctx)
{
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input input_data(istream& tin, bool promt)
{
    size_t n;
    if (promt)
    cerr<<"Marks: ";
    tin>>n;

    Input in;
    in.A.resize(n);
     for (size_t i=0; i<n; i++)
    {
        cerr<<"A["<<i<<"]=";
        cin>>in.A[i];
    }

    if (promt)
    cerr<<"Rows: ";
    tin>>in.bin;
    return in;
}

Input download(const string& address)
{
    stringstream buffer;
    CURL* curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != 0)
        {
            cout << curl_easy_strerror(res);
            exit(1);
        }
    }
    curl_easy_cleanup(curl);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
    return input_data(buffer, false);
}

int main(int argc, char* argv[])
{
    Input in;
    if (argc > 1)
        in = download(argv[1]);
    else
        in = input_data(cin, true);
    auto B = make_histogram(in.A, in.bin);
    show_histogram_svg(B);

    system("pause");
    return 0;
}
